#!/usr/bin/perl

#
# Set defaults
#

$nolocal = 1;
$last = 0;

$curmon = curmon();
$curyear = curyear();
$first_day = 1;
$last_day = 31;
$use_day_range = 0;
$use_m_range = 0;
$squid_prefix = "/usr/local/squid/logs";

#printf "curmon = $curmon\n";

$i = 0;
$curmon_ = $curmon+1;
$last_mon = $curmon_;
$orig_curmon = $curmon;

#
# Get parameters
#

while ($i <= $#ARGV) {
#  printf "$i $ARGV[$i]\n";
  if ($ARGV[$i] eq "\-last")
  {
    $last = 1;
    for($d = $ARGV[$i+1]; $d > 0; $d--) {
#      printf "d = $d ";
      if ($curmon == 0)
      {
        $curmon = 11;
        $curyear = $curyear-1;
      }
      else
      {
        $curmon--;
      }
    }
  }
  elsif ($ARGV[0] eq "\-rotate") {
    $curmon_ = $curmon+1;
    $curyear_ = $curyear;
    system("mv $squid_prefix/access.log $squid_prefix/access.log.$curyear_.$curmon_");
    system("touch $squid_prefix/access.log");
    system("chown squid:squid $squid_prefix/access.log");
    printf "mv -n $squid_prefix/access.log $squid_prefix/access.log.$curyear.$curmon\n";
    printf "touch $squid_prefix/access.log\n";
    printf "chown squid:squid $squid_prefix/access.log\n";
    exit(0);
  }
  elsif ($ARGV[$i] eq "\-d") {
    $curyear_ = $curyear;
    if($ARGV[$i+1] < 1) {
        $curmon += $ARGV[$i+1];
    } else {
        $curmon = $ARGV[$i+1]-1;
    }
    $curmon_ = $curmon+1;

    $i+=1;
    if(($i+1) <= $#ARGV) {
      if($ARGV[$i+1] eq "\-") {
        $first_day = 1;
        $last_day = 31;
      } else {
        $first_day = $last_day = $ARGV[$i+1];
        $i+=1;
      }
      $use_day_range = 1;
    }

    if(($i+1 <= $#ARGV) && ($ARGV[$i+1] eq "\-")) {
        $last_mon = $ARGV[$i+2];
        if($i+3 <= $#ARGV) {
          $last_day = $ARGV[$i+3];
          $i+=1;
        } else {
          $last_day = 31;
        }
        $i+=2;
        if($last_mon != $curmon) {
            $use_m_range = 1;
        }
    }
    if($orig_curmon != $curmon) {
        printf "orig_curmon = $orig_curmon , curmon = $curmon\n";
        $last = 1;
    }
  }
  else
  {
    printf "Incorrect parameter. Resetted to default\n";
    printf "use \-last to see statistics for last month\n";
  };
  $i++;
}; 

if($use_day_range == 0) {
    printf "Date: $curyear $curmon_\n";
} else {
    printf "Date: $curyear $curmon_ ($first_day)\n";
}


$imroot = 0;
$username = $ENV{'USER'};
if ("$username" eq "root")
{
  $imroot = 1;
};

#      (   ...)
$fileout = "access.html";

$getfirst = 1;
$localtraffic = 0;
$deniedtraffic = 0;
$day_night=0;

$first_day_ = $first_day;

while($curmon < $last_mon) {

#    ...
if ($last == 1 && $curmon != $orig_curmon)
{
  $curmon_ = $curmon+1;
  $curyear_ = $curyear;
  $filein = "$squid_prefix/access.log.$curyear_.$curmon_";
  $last_day_ = 31;
}
else
{
  $filein = "$squid_prefix/access.log";
  $last_day_ = $last_day;
};
printf "filein = $filein\n";

open (LOGFILE, $filein);
MAIN_LOOP: while ($str = <LOGFILE>)
{
  chomp ($str);
#  ($time,$elapsed,$who,$tag,$size,$method,$what) = split (" ", $str);
  ($time,$elapsed,$iphost,$tag,$size,$method,$what,$who) = split (" ", $str);

    if(($imroot != 1) && !("$who" eq "$username")) {
      next MAIN_LOOP;
    };

  ($status,$errcode) = split ("/", $tag);
  if ($status eq "TCP_DENIED")
  {
    $deniedtraffic += $size;
    $etime = $time;
    next MAIN_LOOP;
  };

  if ($getfirst == 1)
  {
    $getfirst = 0;
    $btime = $time;
  };

  ($get_sec,$get_min,$get_hour,$get_day,$get_mon,$get_year,$get_wday,$get_yday,$get_isdst) = localtime($time);
  $get_year = $get_year+1900;

  if ( ($use_day_range == 1 && $get_mon == $curmon &&
                               $get_day >= $first_day_ && 
                               $get_day <= $last_day_) ||
       ($use_day_range == 0 && $get_mon == $curmon) ) {
    if (($get_hour > 8) && ($get_hour < 21)) {
      $day_night=0;
    } else {
      $day_night=1;
    }

    if ($clients {$who}[$day_night] == "") {
      $clients {$who}[$day_night] = 0;
    };
    if ($nolocal == 1) {
      if ( (($what =~ /ntu\-kpi\.kiev\.ua/)) ||
           (($what =~ /\:\/\/10\./)) ||
           (($what =~ /\:\/\/213\.133\.163\.18/))
         )   
      {
        $localtraffic += $size;
        $size = 0;
        $etime = $time;
        next MAIN_LOOP;
      }
    };
    $clients {$who}[$day_night] += $size; 
    if($day_night == 0) {
      $monthly_d += $size;
    } else {
      $monthly_n += $size;
    }
    $total += $size;
  };
  $etime = $time;
}
close (LOGFILE);
$curmon += 1;
$first_day_ = 1;
printf "new mon: $curmon\n";
}

# HTML-,     ...
# printf "HTTP 1.1/200 OK\n";
# printf "Content-type: text/plain; charset = koi8-r\n\n";

printf "  :\n\n";
printf "                                  \n";
printf "--------------------------+--------------------+--------------------\n";
foreach (sort keys %clients)
{
  $bytes_d = $clients{$_}[0];
  $bytes_n = $clients{$_}[1];
  if (($bytes_d > 0) or ($bytes_n > 0))
  {
#printf "i $_ i $username !\n";
    if(($imroot == 1) || ("$_" eq "$username"))
    {
      $bytes_d = n2str ($bytes_d);
      $bytes_n = n2str ($bytes_n);
      $_ = c2str ($_);
      printf "$_         $bytes_d $bytes_n\n";
    };
  };
};
printf "--------------------------+--------------------+--------------------\n";
$monthly_d = n2str ($monthly_d);
$monthly_n = n2str ($monthly_n);
printf "         $monthly_d $monthly_n\n";
$localtraffic = n2str ($localtraffic);
printf "         $localtraffic\n";
$den_traf  = n2str ($deniedtraffic);
printf "       $den_traf\n";
$total = n2str ($total);
printf ".      $total\n";
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($btime);
$year = 1900+$year;
$mon_ = mon2str($mon+1);
$mday = mon2str($mday);
printf "     $mday $mon_ $year\n";
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($etime);
$year = 1900+$year;
$mon_ = mon2str($mon+1);
$mday = mon2str($mday);
printf "  $mday $mon_ $year\n";
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year = 1900+$year;
$mon_ = mon2str($mon+1);
$mday = mon2str($mday);
printf "       $mday $mon_ $year\n";

sub curmon
{
  ($sec,$min,$hour,$mday,$cmon,$year,$wday,$yday,$isdst) = localtime(time);
  return $cmon;
};

sub curyear
{
  ($sec,$min,$hour,$mday,$cmon,$year,$wday,$yday,$isdst) = localtime(time);
  return 1900+$year;
};


#sub getmon 
#{
#  ($sec,$min,$hour,$mday,$gmon,$year,$wday,$yday,$isdst) = localtime($_[0]);
#printf "m: $gmon\n";
#  return $gmon;
#};

#sub gethour
#{
#  ($sec,$min,$ghour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($_[0]);
#  return $ghour;                                                             
#};

sub n2str
{
  $res = " ";
  $i = 1;
  if(length($_[0]) < 1) {
    $_[0] = 0;
  }
  foreach $byte (reverse split //, $_[0])
  {
    if ($i == 3)
    {
      $i = 1;
      $byte = " " . $byte;
    }
    else
    {
      $i++
    }
    $res = $byte . $res;
  };
  $res = " " x (20 - length ($res)) . $res;
  return $res;
};

sub c2str
{
  $res = $_[0];
  $res = " " x (16 - length ($res)) . $res;
  return $res;
};

sub mon2str
{
  $res = $_[0];
  if($res < 10) {
    $res = " $res";
  }
  return $res;
};
